//+------------------------------------------------------------------+
//|                                               exp_cci_mt5_v2.mq5 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"

#resource "\\Include\\Controls\\res\\CloseDisable.bmp"
#resource "\\Include\\Controls\\res\\Close.bmp"
#resource "\\Include\\Controls\\res\\RestoreDisable.bmp"
#resource "\\Include\\Controls\\res\\ExpandDisable.bmp"
#resource "\\Include\\Controls\\res\\TurnOn.bmp"
#resource "\\Include\\Controls\\res\\TurnOff.bmp"

string CloseDisable="::Include\\Controls\\res\\CloseDisable.bmp";
string CloseOff="::Include\\Controls\\res\\Close.bmp";
string RollOn="::Include\\Controls\\res\\RestoreDisable.bmp";
string RollOff="::Include\\Controls\\res\\ExpandDisable.bmp";
string TurnOn="::Include\\Controls\\res\\TurnOn.bmp"; //     On
string TurnOff="::Include\\Controls\\res\\TurnOff.bmp";  //    

                                                         //#include "Panel.mqh"
#include <Controls\Panel.mqh>
#include <Controls\BmpButton.mqh>
#include <Controls\Label.mqh>
#include <Tools\DateTime.mqh>
#include<Indicators\Oscilators.mqh>
#include <Trade\Trade.mqh>

input double Risk=1.0;
input double Ksl=2.0;
input double Ktp=4.0;
input int period_CCI_S=100;
input int period_CCI_F=13;
input int Period_ATR=21;
input ENUM_TIMEFRAMES TF_ATR=PERIOD_CURRENT;
input bool signal_01=true;
input bool signal_02=true;
input bool signal_03=true;
input bool signal_04=true;
input bool signal_05=true;
input string CommentOrder="exp_cci";
input string symbol_tester="EURUSD,AUDUSD,USDJPY,USDCAD";

CPanel panel;
CBmpButton button_c;
CBmpButton button_r;
CBmpButton button_t;
CLabel label;
CDateTime dates;

//CiCCI *cci_s;
//CiCCI *cci_f;
//CiATR *atr;
CTrade trade;

int Width;
int Height;

bool show_close=false;
bool show_roll = false;
bool show_turn = false;

bool MarketWatch=true;
int total_symbol;

ENUM_ORDER_TYPE Signal[];
ENUM_ORDER_TYPE trend[];
//MqlTradeRequest   m_request;         // request data
//MqlTradeResult    m_result;          // result data
//MqlTradeCheckResult m_check_result;  // result check data
int               m_cci_s[];
int               m_cci_f[];
int               m_atr[];

datetime date1;
datetime date2;
MqlDateTime str1,str2,str3;
string   Symbols[];
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- create timer
   EventSetTimer(1);
//panel=new CPanel();
//button_c=new CBmpButton();
//button_r=new CBmpButton();
//button_t=new CBmpButton();
//label=new CLabel();

//if(MQLInfoInteger(MQL_VISUAL_MODE))MarketWatch=false;
//if(MQLInfoInteger(MQL_TESTER))MarketWatch=false;
//if(MQLInfoInteger(MQL_OPTIMIZATION))MarketWatch=false;

   total_symbol=SymbolsTotal(MarketWatch);

   if(MQLInfoInteger(MQL_VISUAL_MODE) || MQLInfoInteger(MQL_TESTER) || MQLInfoInteger(MQL_OPTIMIZATION))
     {
      string sep=",";                  //     
      ushort u_sep;                    //   
      if(symbol_tester=="ALL")
        {
         MarketWatch=false;
         total_symbol=SymbolsTotal(MarketWatch);
        }
      else
        {
         u_sep=StringGetCharacter(sep,0);
         total_symbol=StringSplit(symbol_tester,u_sep,Symbols);
         //---    
         PrintFormat(" : %d.   '%s'   %d",total_symbol,sep,u_sep);
         //---      
         if(total_symbol>0)
           {
            for(int i=0;i<total_symbol;i++)
              {
               PrintFormat("Symbols[%d]=\"%s\"",i,Symbols[i]);
              }
           }
        }
     }

//trade=new CTrade();
//cci_s=new CiCCI();
//cci_f=new CiCCI();
//atr=new CiATR();

   ArrayResize(Signal,total_symbol);
   ArrayResize(trend,total_symbol);

   ArrayResize(m_cci_s,total_symbol);
   ArrayResize(m_cci_f,total_symbol);
   ArrayResize(m_atr,total_symbol);

   ArrayInitialize(Signal,WRONG_VALUE);
   ArrayInitialize(trend,WRONG_VALUE);

   ArrayInitialize(m_cci_s,0);
   ArrayInitialize(m_cci_f,0);
   ArrayInitialize(m_atr,0);

   from_create3();
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();
//delete(panel);
//delete(button_c);
//delete(button_r);
//delete(button_t);
//delete(label);

//delete(cci_s);
//delete(cci_f);
//delete(atr);
// delete(trade);

   ObjectsDeleteAll(0);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
//void OnTick()
//  {
////---
//
//  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
//void OnTimer()
void OnTick()
  {
   total_symbol=SymbolsTotal(MarketWatch);

   if(MQLInfoInteger(MQL_VISUAL_MODE) || MQLInfoInteger(MQL_TESTER) || MQLInfoInteger(MQL_OPTIMIZATION))
     {
      string sep=",";                  //     
      ushort u_sep;                    //    
      if(symbol_tester=="ALL")
        {
         MarketWatch=false;
         total_symbol=SymbolsTotal(MarketWatch);
        }
      else
        {
         u_sep=StringGetCharacter(sep,0);
         total_symbol=StringSplit(symbol_tester,u_sep,Symbols);
        }
     }

   double price=0.0;
   string symbol;
   for(int i=0;i<total_symbol;i++)
     {

      if(MQLInfoInteger(MQL_VISUAL_MODE) || MQLInfoInteger(MQL_TESTER) || MQLInfoInteger(MQL_OPTIMIZATION))
        {
         if(symbol_tester=="ALL")symbol=SymbolName(i,MarketWatch);
         else symbol=Symbols[i];
        }
      else symbol=SymbolName(i,MarketWatch);

      Signal[i]=Get_Signal(symbol,i);
      double SL=Dynamic_Stop(symbol,i,Ksl);
      double TP=Dynamic_Stop(symbol,i,Ktp);
      double Bid=SymbolInfoDouble(symbol,SYMBOL_BID);
      double Ask=SymbolInfoDouble(symbol,SYMBOL_ASK);
      int digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
      if(!disabled(symbol))continue;
      if(Signal[i]==ORDER_TYPE_BUY)
        {
         if(PositionSelect(symbol))
           {
            if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)trade.PositionClose(symbol);
           }
         else
           {
            price=NormalizeDouble(Ask,digits);
            trade.Buy(Volume(symbol,Risk/total_symbol,SL),symbol,price,0,0,CommentOrder);
           }
        }
      if(Signal[i]==ORDER_TYPE_SELL)
        {
         if(PositionSelect(symbol))
           {
            if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)trade.PositionClose(symbol);
           }
         else
           {
            price=NormalizeDouble(Bid,digits);
            trade.Sell(Volume(symbol,Risk/total_symbol,SL),symbol,price,0,0,CommentOrder);
           }
        }

      ModifySL(symbol,SL);
      ModifyTP(symbol,TP);
     }
//---
   Width=ChartWidthInPixels();
   Height=ChartHeightInPixelsGet();

   if(show_turn)from_create2();
   if(!show_turn)from_create1();
   if(!show_turn && !show_roll)from_create3();

  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {

//---
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
      if(sparam=="Close")
        {
         show_close=button_c.Pressed();
         if(show_close)ExpertRemove();
        }
      if(sparam=="Roll")show_roll=button_r.Pressed();
      if(sparam=="Turn")show_turn=button_t.Pressed();

      if(show_turn)
        {
         ObjectsDeleteAll(0);
         from_create2();
        }

      if(!show_turn)
        {
         ObjectsDeleteAll(0);
         from_create1();
        }

      if(!show_turn && !show_roll)
        {
         //ObjectsDeleteAll(0);
         from_create3();
        }
     }

  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
bool disabled(string symbol)
  {
   if(SymbolInfoInteger(symbol,SYMBOL_TRADE_MODE)==SYMBOL_TRADE_MODE_DISABLED)return(false);
   if(!TerminalInfoInteger(TERMINAL_TRADE_ALLOWED))return(false);
   if(!MQLInfoInteger(MQL_TRADE_ALLOWED))return(false);
   if(!AccountInfoInteger(ACCOUNT_TRADE_EXPERT))return(false);
   if(!AccountInfoInteger(ACCOUNT_TRADE_ALLOWED))return(false);
//if(!SessionTrade(symbol))return(false);
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//bool SessionTrade(string symbol)
//  {
//   TimeToStruct(TimeCurrent(),str3);
////if(SymbolInfoSessionTrade(symbol,(ENUM_DAY_OF_WEEK)str3.day_of_week,0,date1,date2)){return(false);}
////else
////  {
//   SymbolInfoSessionTrade(symbol,(ENUM_DAY_OF_WEEK)str3.day_of_week,0,date1,date2);
//   TimeToStruct(date1,str1);
//   TimeToStruct(date2,str2);
//   if(str3.hour<str1.hour)return(false);
//   if(str3.hour>str2.hour)return(false);
//   //if(str3.hour==str1.hour && str3.min<str1.min)return(false);
//// }
//   return(true);
//  }
//+------------------------------------------------------------------+
void ModifyTP(string symbol,double tp)
  {
   if(tp<=0)return;
   double _sl=0.0;
   double _tp=0.0;
   if(PositionSelect(symbol))
     {
      if(PositionGetDouble(POSITION_TP)==0)
        {
         double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
         int digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);

         if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
           {
            _tp=NormalizeDouble(SymbolInfoDouble(symbol,SYMBOL_BID)+tp*point,digits);
            _sl=PositionGetDouble(POSITION_SL);
           }
         if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
           {
            _tp=NormalizeDouble(SymbolInfoDouble(symbol,SYMBOL_ASK)-tp*point,digits);
            _sl=PositionGetDouble(POSITION_SL);
           }
         //if(OrderCheck(m_request,m_check_result))
         //  {
         //   if(OrderSend(m_request,m_result)){}
         //   else Print("  - ",m_result.retcode);
         //  }
         trade.PositionModify(symbol,_sl,_tp);
        }
     }
  }
//+------------------------------------------------------------------+
void ModifySL(string symbol,double sl)
  {
   if(sl<=0)return;
   double _sl=0.0;
   double _tp=0.0;
   if(PositionSelect(symbol))
     {
      if(PositionGetDouble(POSITION_SL)==0)
        {
         double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
         int digits=(int)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
         if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
           {
            _tp=PositionGetDouble(POSITION_TP);
            _sl=NormalizeDouble(SymbolInfoDouble(symbol,SYMBOL_BID)-sl*point,digits);
           }
         if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
           {
            _tp=PositionGetDouble(POSITION_TP);
            _sl=NormalizeDouble(SymbolInfoDouble(symbol,SYMBOL_ASK)+sl*point,digits);
           }
         //if(OrderCheck(m_request,m_check_result))
         //  {
         //   if(OrderSend(m_request,m_result)){}
         //   else Print("  - ",m_result.retcode);
         //  }
         trade.PositionModify(symbol,_sl,_tp);
        }
     }
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//double Dynamic_Stop(string symbol)
//  {
//   if(Bars(symbol,TF_ATR)<Period_ATR+1)return(WRONG_VALUE);
//   if(!atr.Create(symbol,TF_ATR,Period_ATR))return(WRONG_VALUE);
//   atr.Refresh();
//   double vol=atr.GetData(0,1)/SymbolInfoDouble(symbol,SYMBOL_POINT);
//   return(vol);
//  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Dynamic_Stop(string symbol,int index,double k)
  {
   double atr[1];

   if(Bars(symbol,TF_ATR)<Period_ATR+1)return(WRONG_VALUE);

   if(m_atr[index]==INVALID_HANDLE || m_atr[index]==0){m_atr[index]=iATR(symbol,TF_ATR,Period_ATR);return(WRONG_VALUE);}
   if(CopyBuffer(m_atr[index],0,1,1,atr)<1)return(WRONG_VALUE);

   double vol=atr[0]/SymbolInfoDouble(symbol,SYMBOL_POINT)*k;
   if(vol<=SymbolInfoInteger(symbol,SYMBOL_TRADE_STOPS_LEVEL))
     {
      vol*=2.0;
     }
   vol=NormalizeDouble(vol/SymbolInfoDouble(symbol,SYMBOL_TRADE_TICK_SIZE),0)*SymbolInfoDouble(symbol,SYMBOL_TRADE_TICK_SIZE);

   return(vol);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Volume(string symbol,double risk,double sl)
  {
   double lot=0.0;
   double procent=0.0;
   double MinLot=SymbolInfoDouble(symbol,SYMBOL_VOLUME_MIN);
   double MaxLot=SymbolInfoDouble(symbol,SYMBOL_VOLUME_MAX);
   double balans= AccountInfoDouble(ACCOUNT_MARGIN_FREE);
   double tc = SymbolInfoDouble(symbol,SYMBOL_TRADE_CONTRACT_SIZE);
   double tv = SymbolInfoDouble(symbol,SYMBOL_TRADE_TICK_VALUE_LOSS);
   double ts=SymbolInfoDouble(symbol,SYMBOL_TRADE_TICK_SIZE);
   double point=SymbolInfoDouble(symbol,SYMBOL_POINT);
   procent=(balans/100.0)*risk;

   switch((ENUM_SYMBOL_CALC_MODE)SymbolInfoInteger(symbol,SYMBOL_TRADE_CALC_MODE))
     {
      case SYMBOL_CALC_MODE_FOREX:if(sl!=0 && point!=0 && tc!=0) lot=procent/(sl*point*tc);break;
      case SYMBOL_CALC_MODE_FUTURES:if(sl!=0 && point!=0 && tv!=0 && ts!=0) lot=procent/(sl*point*(tv/ts));break;
      case SYMBOL_CALC_MODE_CFD:if(sl!=0 && point!=0 && tc!=0) lot=procent/(sl*point*tc);break;
      case SYMBOL_CALC_MODE_CFDINDEX:if(sl!=0 && point!=0 && tc!=0) lot=procent/(sl*point*tc);break;
      case SYMBOL_CALC_MODE_CFDLEVERAGE:if(sl!=0 && point!=0 && tc!=0) lot=procent/(sl*point*tc);break;
      case SYMBOL_CALC_MODE_EXCH_STOCKS:if(sl!=0 && point!=0 && tc!=0) lot=procent/(sl*point*tc);break;
      case SYMBOL_CALC_MODE_EXCH_FUTURES:if(sl!=0 && point!=0 && tv!=0 && ts!=0) lot=procent/(sl*point*(tv/ts));break;
      case SYMBOL_CALC_MODE_EXCH_FUTURES_FORTS:if(sl!=0 && point!=0 && tv!=0 && ts!=0) lot=procent/(sl*point*(tv/ts));break;
     }

   if(lot<MinLot)lot=MinLot;
   if(lot>MaxLot)lot=MaxLot;

   if(MinLot==0.001) return(NormalizeDouble(lot,3));
   if(MinLot==0.01)  return(NormalizeDouble(lot,2));
   if(MinLot==0.1)   return(NormalizeDouble(lot,1));

   return(NormalizeDouble(lot,0));
  }
//+------------------------------------------------------------------+
//ENUM_ORDER_TYPE Get_Signal(string symbol,int index)
//  {
//
//   if(Bars(symbol,PERIOD_CURRENT)<period_CCI_S+1)return(WRONG_VALUE);
//   if(Bars(symbol,TF_ATR)<Period_ATR+1)return(WRONG_VALUE);
//
//   if(!cci_s.Create(symbol,NULL,period_CCI_S,PRICE_CLOSE))return(WRONG_VALUE);
//   if(!cci_f.Create(symbol,NULL,period_CCI_F,PRICE_CLOSE))return(WRONG_VALUE);
//   if(!atr.Create(symbol,TF_ATR,Period_ATR))return(WRONG_VALUE);
//
//   cci_s.Refresh();
//   cci_f.Refresh();
//
//   double CCI_S1=cci_s.GetData(0,1);
//   double CCI_S2=cci_s.GetData(0,2);
//   double CCI_F1=cci_f.GetData(0,1);
//   double CCI_F2=cci_f.GetData(0,2);
//
//   if(CCI_S1>100.0)trend[index]=ORDER_TYPE_BUY;
//   if(CCI_S1<-100.0)trend[index]=ORDER_TYPE_SELL;
//
//   if(CCI_S1>100.0  &&  CCI_S2<100.0)trend[index]=ORDER_TYPE_BUY;
//   if(CCI_S1<-100.0 && CCI_S2>-100.0)trend[index]=ORDER_TYPE_SELL;
//
//   if(trend[index]==ORDER_TYPE_BUY)
//     {
//      if(CCI_F1<-100.0)return(ORDER_TYPE_BUY);
//      if(CCI_F1<-100.0 && CCI_F2>-100.0)return(ORDER_TYPE_BUY);
//      if(CCI_F1>-100.0 && CCI_F2<-100.0)return(ORDER_TYPE_BUY);
//      if(CCI_F1>100.0 && CCI_F2<100.0)return(ORDER_TYPE_BUY);
//      if(CCI_F1>100.0)return(ORDER_TYPE_BUY);
//     }
//   if(trend[index]==ORDER_TYPE_SELL)
//     {
//      if(CCI_F1>100)return(ORDER_TYPE_SELL);
//      if(CCI_F1>100 && CCI_F2<100)return(ORDER_TYPE_SELL);
//      if(CCI_F1<100 && CCI_F2>100)return(ORDER_TYPE_SELL);
//      if(CCI_F1<-100 && CCI_F2>-100)return(ORDER_TYPE_SELL);
//      if(CCI_F1<-100)return(ORDER_TYPE_SELL);
//     }
//
//   return(WRONG_VALUE);
//  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
ENUM_ORDER_TYPE Get_Signal(string symbol,int index)
  {
   double cci_s[3];
   double cci_f[3];
   ArrayInitialize(cci_s,0);
   ArrayInitialize(cci_f,0);
   if(Bars(symbol,PERIOD_CURRENT)<period_CCI_S+1)return(WRONG_VALUE);
   if(Bars(symbol,TF_ATR)<Period_ATR+1)return(WRONG_VALUE);

   if(m_cci_s[index]==INVALID_HANDLE ||  m_cci_s[index]==0){m_cci_s[index]=iCCI(symbol,PERIOD_CURRENT,period_CCI_S,PRICE_CLOSE);return(WRONG_VALUE);}
   if(m_cci_f[index]==INVALID_HANDLE ||  m_cci_f[index]==0){m_cci_f[index]=iCCI(symbol,PERIOD_CURRENT,period_CCI_F,PRICE_CLOSE);return(WRONG_VALUE);}

   int i=0;
   do
     {
      if(i>Bars(symbol,PERIOD_CURRENT))break;

      if(CopyBuffer(m_cci_s[index],0,i,3,cci_s)<3) return(WRONG_VALUE);

      if(cci_s[1]>100.0)trend[index]=ORDER_TYPE_BUY;
      if(cci_s[1]<-100.0)trend[index]=ORDER_TYPE_SELL;
      if(cci_s[1]>100.0  &&  cci_s[0]<100.0)trend[index]=ORDER_TYPE_BUY;
      if(cci_s[1]<-100.0 && cci_s[0]>-100.0)trend[index]=ORDER_TYPE_SELL;
      i++;
     }
   while(trend[index]==WRONG_VALUE && !IsStopped());

   if(CopyBuffer(m_cci_f[index],0,0,3,cci_f)<3) return(WRONG_VALUE);

   if(trend[index]==ORDER_TYPE_BUY)
     {
      if(signal_01 && cci_f[1]<-100.0)return(ORDER_TYPE_BUY);
      if(signal_02 && cci_f[1]<-100.0 && cci_f[0]>-100.0)return(ORDER_TYPE_BUY);
      if(signal_03 && cci_f[1]>-100.0 && cci_f[0]<-100.0)return(ORDER_TYPE_BUY);
      if(signal_04 && cci_f[1]>100.0 && cci_f[0]<100.0)return(ORDER_TYPE_BUY);
      if(signal_05 && cci_f[1]>100.0)return(ORDER_TYPE_BUY);
     }
   if(trend[index]==ORDER_TYPE_SELL)
     {
      if(signal_01 && cci_f[1]>100)return(ORDER_TYPE_SELL);
      if(signal_02 && cci_f[1]>100 && cci_f[0]<100)return(ORDER_TYPE_SELL);
      if(signal_03 && cci_f[1]<100 && cci_f[0]>100)return(ORDER_TYPE_SELL);
      if(signal_04 && cci_f[1]<-100 && cci_f[0]>-100)return(ORDER_TYPE_SELL);
      if(signal_05 && cci_f[1]<-100)return(ORDER_TYPE_SELL);
     }

   return(WRONG_VALUE);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void from_create1()
  {
   int x=Width-20;

   panel.Create(0,"Panel",0,0,0,Width-20,20);
   panel.BorderType(BORDER_RAISED);
   panel.ColorBackground(clrDodgerBlue);

   button_c.Create(0,"Close",0,Width-40,0,Width-20,20);
   button_c.BmpNames(CloseDisable,CloseOff);
   button_c.Pressed(show_close);

   button_r.Create(0,"Roll",0,Width-60,0,Width-40,20);
   button_r.BmpNames(RollOn,RollOff);
   button_r.Pressed(show_roll);

   button_t.Create(0,"Turn",0,Width-80,2,Width-60,22);
   button_t.BmpNames(TurnOn,TurnOff);
   button_t.Pressed(show_turn);

   label.Create(0,"Time",0,Width-280,0,0,0);
   label.Font("");
   label.Text(TimeToString(TimeCurrent(),TIME_DATE|TIME_SECONDS)+" : "+dates.DayName());
   label.Color(clrWhite);
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void from_create2()
  {
//int x=80;
   int y=Height-20;

   panel.Create(0,"Panel",0,3,y,60,Height);
   panel.BorderType(BORDER_RAISED);
   panel.ColorBackground(clrDodgerBlue);

   button_c.Create(0,"Close",0,42,y,Width-20,20);
   button_c.BmpNames(CloseDisable,CloseOff);
   button_c.Pressed(show_close);

   button_r.Create(0,"Roll",0,22,y,Width-40,20);
   button_r.BmpNames(RollOn,RollOff);
   button_r.Pressed(show_roll);

   button_t.Create(0,"Turn",0,5,Height-18,60,Height);
   button_t.BmpNames(TurnOn,TurnOff);
   button_t.Pressed(show_turn);

   ChartRedraw();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void from_create3()
  {

   panel.Create(0,"Panel",0,0,0,Width-20,20);
   panel.BorderType(BORDER_RAISED);
   panel.ColorBackground(clrDodgerBlue);

   button_c.Create(0,"Close",0,Width-40,0,Width-20,20);
   button_c.BmpNames(CloseDisable,CloseOff);
   button_c.Pressed(show_close);

   button_r.Create(0,"Roll",0,Width-60,0,Width-40,20);
   button_r.BmpNames(RollOn,RollOff);
   button_r.Pressed(show_roll);

   button_t.Create(0,"Turn",0,Width-80,2,Width-60,22);
   button_t.BmpNames(TurnOn,TurnOff);
   button_t.Pressed(show_turn);

   label.Create(0,"Time",0,Width-280,0,0,0);
   label.Font("");
   label.Text(TimeToString(TimeCurrent(),TIME_DATE|TIME_SECONDS)+" : "+dates.DayName());
   label.Color(clrWhite);

   panel.Create(0,"Panel2",0,0,20,Width-20,Height);
   panel.BorderType(BORDER_SUNKEN);
   panel.ColorBackground(clrWhiteSmoke);

   int x = 5;
   int y = 25;

   for(int i=0;i<total_symbol;i++)
     {
      string symbol;
      if(MQLInfoInteger(MQL_VISUAL_MODE) || MQLInfoInteger(MQL_TESTER) || MQLInfoInteger(MQL_OPTIMIZATION))
        {
         if(symbol_tester=="ALL")symbol=SymbolName(i,MarketWatch);
         else symbol=Symbols[i];
        }
      else symbol=SymbolName(i,MarketWatch);

      label.Create(0,symbol,0,x,y,0,0);
      label.Font("");
      label.Text(symbol);
      label.Color(clrGreen);

      label.Create(0,"_"+(string)i,0,x+100,y,0,0);
      label.Font("");
      label.Text(":");
      label.Color(clrBlue);

      label.Create(0,"_"+(string)i,0,x+160,y,0,0);
      label.Font("");
      label.Text(":");
      label.Color(clrBlue);

      label.Create(0,"Arrow__"+(string)i,0,x+140,y+2,0,0);
      label.Font("Wingdings");
      label.Text(CharToString((uchar)arrow(trend[i])));
      label.Color(Colorarrow(trend[i]));

      label.Create(0,"Arrow__"+(string)i,0,x+210,y+2,0,0);
      label.Font("Wingdings");
      label.Text(CharToString((uchar)arrow(Signal[i])));
      label.Color(Colorarrow(Signal[i]));


      y+=15;
      if(y>=Height-20)
        {
         x+=230;
         y=25;
        }
     }
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int arrow(ENUM_ORDER_TYPE sig)
  {
   if(sig==WRONG_VALUE)return(251);
   if(sig==ORDER_TYPE_BUY)return(233);
   if(sig==ORDER_TYPE_SELL)return(234);
   return(0);
  }
//+------------------------------------------------------------------+
color Colorarrow(ENUM_ORDER_TYPE sig)
  {
   if(sig==WRONG_VALUE)return(clrMediumAquamarine);
   if(sig==ORDER_TYPE_BUY)return(clrBlue);
   if(sig==ORDER_TYPE_SELL)return(clrRed);
   return(0);
  }
//+------------------------------------------------------------------+
//|       .             |
//+------------------------------------------------------------------+
int ChartWidthInPixels(const long chart_ID=0)
  {
//---      
   long result=-1;
//---   
   ResetLastError();
//---   
   if(!ChartGetInteger(chart_ID,CHART_WIDTH_IN_PIXELS,0,result))
     {
      //---       ""
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
//---    
   return((int)result);
  }
//+------------------------------------------------------------------+
//|       .             |
//+------------------------------------------------------------------+
int ChartHeightInPixelsGet(const long chart_ID=0,const int sub_window=0)
  {
//---      
   long result=-1;
//---   
   ResetLastError();
//---   
   if(!ChartGetInteger(chart_ID,CHART_HEIGHT_IN_PIXELS,sub_window,result))
     {
      //---       ""
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
//---    
   return((int)result);
  }
//+------------------------------------------------------------------+
